

function parsepacket(packet) 
global turn;
global endgame;
global currentpiece; %a string?
global currentpiecevar;
global myCursor;
global titlestring;

title(titlestring);
if (~isempty(packet>0))
mtype=packet(1);
if (mtype == 0) %reset game
   % packet(1)
   titlestring= 'New Game! Welcome to ECE 4760 Mouseless Chess! White to play first';
    %title('New Game! Welcome to ECE 4760 Mouseless Chess! White to play first');
    %set(0,'PointerLocation',[800 800]);  
    move(230-10,230-15,myCursor);
    resetboard;
    turn = 1;
    %call initialization function here
    
elseif (mtype == 1) %move the current piece
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    move(newxloc-30, newyloc-30, currentpiecevar);
    move(newxloc-10,newyloc-15,myCursor);
    titlestring =strcat(getOppositeColor(turn),'''s turn');
    %title(titlestring);
elseif (mtype == 2) %error for taking a piece that is not yours
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    titlestring= 'That is not your piece. Please choose again';
    %title('That is not your piece. Please choose again');
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
elseif (mtype == 3) %error for taking a piece that is pinned
    %packet(1)
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    titlestring= 'That piece is pinned, you can''t move it';
    %title('That piece is pinned, you can''t move it');
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
elseif (mtype == 4) %error for invalid move, and to place piece in original position
    %packet(1)
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    %selpiece = fread(inport, 1, 'uint8');
    lastbyte= packet(5);
    rowindex = bitshift(lastbyte, -4);
    rowindex = bitand(rowindex, 7);
    colindex = bitand(lastbyte, 7);
%     piecevar=getPieceVar(selpiece);
    titlestring='That is an invalid move. Please choose again.';
    %title('That is an invalid move. Please choose again.');
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
    drop(colindex*60, rowindex*60, currentpiecevar);
elseif (mtype == 5) %drop a piece in the square the mouse is over
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc=packet(2);
    newyloc=packet(3);
    dropnewxloc= packet(4);
    dropnewyloc= packet(5);
    titlestring=[getPiece(currentpiece) ' to ' getCol(dropnewxloc) getRow(dropnewyloc) '. ' getOppositeColor(~turn) '''s turn'];
    %title(titlestring);
%     piecevar=getPieceVar(selpiece);
    drop(dropnewxloc,dropnewyloc, currentpiecevar);
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
    %pause(.04);
    turn = ~turn;
elseif (mtype == 6) %capture a piece
    newxloc= packet(5);
    newyloc= packet(6);
%     selpiece= packet(4);
    captpiece= packet(4);
    titlestring=[getPiece(currentpiece) ' captured ' getPiece(captpiece) ' at ' getCol(newxloc) getRow(newyloc) '. ' getOppositeColor(~turn) '''s turn'];
    %title(titlestring);
    set(getPieceVar(captpiece), 'Visible', 'off');
    drop(newxloc, newyloc, currentpiecevar);
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
    turn = ~turn;   
elseif (mtype == 7) %castle
    %packet
    newxloc=packet(2);
    newyloc=packet(3);
    dropnewxloc= packet(4);
    dropnewyloc= packet(5);
    lastint= packet(6);
    %captpiece = packet(5);
%     locationsbyte=packet(5);
    row = bitand(lastint, 7);
    col = bitand(bitshift(lastint,-3), 7);
    rookvar = getPieceVar(bitand(bitshift(lastint,-6), 31));
%     king = bitand(bitshift(castlebyte,-6), 31);
%     rook = bitand(bitshift(castlebyte,-11), 31);
%     kingvar = getPieceVar(king);
   
%     rookvar = getPieceVar(rookbyte);
    drop(dropnewxloc, dropnewyloc, currentpiecevar);
    drop(col*60, row*60, rookvar);
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
    turn = ~turn;
    titlestring = [getOppositeColor(turn) ' castled. ' getOppositeColor(~turn) '''s turn'];
    %title(titlestring);
elseif (mtype == 8) %cursor move and check
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    titlestring=[getOppositeColor(turn) ', you are in check'];
    %title(titlestring);
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
    %turn = ~turn;   
elseif (mtype == 9) %piece move and check
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    move(newxloc-30, newyloc-30, currentpiecevar);
    move(newxloc-10,newyloc-15,myCursor);
    titlestring=[getOppositeColor(turn) ', you are in check'];
    %title(titlestring);
    %drop(newxloc,newyloc, currentpiecevar);
    %turn = ~turn;    
elseif (mtype == 10) %stalemate
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    titlestring= 'The game is at a stalemate. Press reset to start a new game';
    %title('The game is at a stalemate. Press reset to start a new game'); 
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
elseif (mtype == 11) %checkmate
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    titlestring = ['Checkmate! ' getOppositeColor(~turn) ' wins! Press reset to start a new game.']; 
    %title(titlestring);
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
elseif (mtype == 12) %queening a pawn
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
%     selpiece = fread(inport, 1, 'uint8');
%     selpiece= packet(4);
    currentpiecevar=pawn2queen(currentpiecevar);
    titlestring = [getOppositeColor(turn) ' ' getPiece(currentpiece) ' queened at ' getCol(newxloc) getRow(newyloc)+49 '. ' getOppositeColor(~turn) '''s turn'];
    %title(titlestring);
%     pieceToArray(selpiece);
    turn = ~turn;
    %set(0,'PointerLocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
elseif (mtype == 13) %end game
    endgame = 1;
    titlestring= 'thanks for playing';
    %title('thanks for playing');
elseif (mtype == 14) %pointer movement

    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    move(newxloc-10,newyloc-15,myCursor);
    pause(.04);
    %title(' ');
elseif (mtype == 15) %pick up a piece
    %packet;
    newxloc= packet(2);
    newyloc= packet(3);
    currentpiece= packet(4);
    currentpiecevar = getPieceVar(currentpiece);
    move(newxloc-30, newyloc-30, currentpiecevar);
    move(newxloc-10,newyloc-15,myCursor);
%     titlestring =strcat(getOppositeColor(turn),'''s turn');
%     title(titlestring);
elseif (mtype == 16) %place a piece back where it was. don't change turn
    %newxloc = fread(inport, 1, 'uint16');
    %newyloc = fread(inport, 1, 'uint16');
    newxloc= packet(2);
    newyloc= packet(3);
    drop(newxloc, newyloc, currentpiecevar);
    %set(0, 'Pointerlocation', [newxloc newyloc]);
    move(newxloc-10,newyloc-15,myCursor);
    titlestring =strcat(getOppositeColor(~turn),'''s turn');
    %title(titlestring);
else
    fprintf('invalid MCU command\n');
end
% wastebytes= mod(inport.BytesAvailable,7);
% if (wastebytes  > 0)
%     fread(inport, wastebytes);
% end
end
end

function outcol = getCol(col)
        if col>=0 && col<60
            outcol = 'A';
        elseif col>=60 && col<120
            outcol = 'B';
        elseif col>=120 && col<180
            outcol = 'C';
        elseif col>=180 && col<240
            outcol = 'D';
        elseif col>=240 && col<300
            outcol = 'E';
        elseif col>=300 && col<360
            outcol = 'F';
        elseif col>=360 && col<420
            outcol = 'G';
        elseif col>=420 && col<480
            outcol = 'H';
        end
end

function stringturn = getOppositeColor(turn)
    if (turn == 0)
        stringturn = 'Black';
    else 
        stringturn = 'White';
    end
end

function [piecestring] = getPiece(index)
    switch index
        case 0
            piecestring = 'Black pawn';
        case 1
            piecestring = 'Black pawn';
        case 2
            piecestring = 'Black pawn';
        case 3
            piecestring = 'Black pawn';
        case 4
            piecestring = 'Black pawn';
        case 5
            piecestring = 'Black pawn';
        case 6
            piecestring = 'Black pawn';
        case 7
            piecestring = 'Black pawn';
        case 8
            piecestring = 'White pawn';
        case 9
            piecestring = 'White pawn';
        case 10
            piecestring = 'White pawn';
        case 11
            piecestring = 'White pawn';
        case 12
            piecestring = 'White pawn';
        case 13
            piecestring = 'White pawn';
        case 14
            piecestring = 'White pawn';
        case 15
            piecestring = 'White pawn';
        case 16
            piecestring = 'White rook';
        case 17
            piecestring = 'White rook';
        case 18
            piecestring = 'Black rook';
        case 19
            piecestring = 'Black rook';
        case 20
            piecestring = 'White knight';
        case 21
            piecestring = 'White knight';
        case 22
            piecestring = 'Black knight';
        case 23
            piecestring = 'Black knight';
        case 24
            piecestring = 'White bishop';
        case 25
            piecestring = 'White bishop';
        case 26 
            piecestring = 'Black bishop';
        case 27
            piecestring = 'Black bishop';
        case 28
            piecestring = 'White queen';
        case 29 
            piecestring = 'Black queen';
        case 30
            piecestring = 'White king';
        case 31
            piecestring = 'Black king';
        otherwise
            piecestring = 'ERROR';
    end
end

function [piecevar] = getPieceVar(index)
    
    global blackrookA;
    global blackknightA;
    global blackbishopA;
    global blackqueen;
    global blackking;
    global blackbishopB;
    global blackknightB;
    global blackrookB;
    global blackpawnA;
    global blackpawnB;
    global blackpawnC;
    global blackpawnD;
    global blackpawnE;
    global blackpawnF;
    global blackpawnG;
    global blackpawnH;
    global whiterookA;
    global whiteknightA;
    global whitebishopA;
    global whiteking;
    global whitequeen;
    global whitebishopB;
    global whiteknightB;
    global whiterookB;
    global whitepawnA;
    global whitepawnB;
    global whitepawnC;
    global whitepawnD;
    global whitepawnE;
    global whitepawnF;
    global whitepawnG;
    global whitepawnH;
    switch index
        case 0
            piecevar = blackpawnA;
        case 1
            piecevar = blackpawnB;
        case 2
            piecevar = blackpawnC;
        case 3
            piecevar = blackpawnD;
        case 4
            piecevar = blackpawnE;
        case 5
            piecevar = blackpawnF;
        case 6
            piecevar = blackpawnG;
        case 7
            piecevar = blackpawnH;
        case 8
            piecevar = whitepawnA;
        case 9
            piecevar = whitepawnB;
        case 10
            piecevar = whitepawnC;
        case 11
            piecevar = whitepawnD;
        case 12
            piecevar = whitepawnE;
        case 13
            piecevar = whitepawnF;
        case 14
            piecevar = whitepawnG;
        case 15
            piecevar = whitepawnH;
        case 16
            piecevar = whiterookA;
        case 17
            piecevar = whiterookB;
        case 18
            piecevar = blackrookA;
        case 19
            piecevar = blackrookB;
        case 20
            piecevar = whiteknightA;
        case 21
            piecevar = whiteknightB;
        case 22
            piecevar = blackknightA;
        case 23
            piecevar = blackknightB;
        case 24
            piecevar = whitebishopA;
        case 25
            piecevar = whitebishopB;
        case 26 
            piecevar = blackbishopA;
        case 27
            piecevar = blackbishopB;
        case 28
            piecevar = whitequeen;
        case 29 
            piecevar = blackqueen;
        case 30
            piecevar = whiteking;
        case 31
            piecevar = blackking;
    end
end

function outrow = getRow(row)
       if row>=0 && row<60
            outrow = '1';
        elseif row>=60 && row<120
            outrow = '2';
        elseif row>=120 && row<180
            outrow = '3';
        elseif row>=180 && row<240
            outrow = '4';
        elseif row>=240 && row<300
            outrow = '5';
        elseif row>=300 && row<360
            outrow = '6';
        elseif row>=360 && row<420
            outrow = '7';
        elseif row>=420 && row<480
            outrow = '8';
        end
end

%move piece to location specified by x and y coordinates
%does not place directly in a box (can be used for dragging a piece)
function move(x,y,piece)
    set(piece,'XData',x,'YData',y);
    uistack(piece,'top');
    pause(.04);
end

%drop a piece in the box of the chess board at the specified location
function drop(x,y,piece)
    %x=x-30;
    %y=y-30;
    if (x < 0)
        xC = 0;
    elseif (x > 420)
        xC = 420;
    else
        xC= int16(x);
        xC= xC/60;  %re-adjust piece to fit square
        xC= xC*60;
    end
    
    if (y < 0)
        yC = 0;
    elseif (y > 420)
        yC = 420;
    else        
        yC= int16(y);
        yC= yC/60;
        yC= yC*60;
    end
    uistack(piece,'top');
    set(piece,'XData',xC,'YData',yC);
    pause(.04);
end

function [queen] = pawn2queen(pawn)

xloc= get(pawn,'XData');
yloc= get(pawn,'YData');

global alpha_data_queen;

    global turn;
        %bounds checking
        if (xloc > 420)
            xloc = 420;
        end
        if (yloc > 420)
            yloc = 420;
        end
    
    %row = int8(yloc/60);
    %col = int8(xloc/60);

    delete(pawn);   %delete old pawn
    if (turn) %decide whether to create black queen image or white queen image
        newqueen= imread(strcat('pieces\blackqueen1','.png'));
        newqueen= imrotate(newqueen,180,'crop');
    else
        newqueen=imread(strcat('pieces\whitequeen1','.png'));
        newqueen=imrotate(newqueen,180,'crop');
    end
       queen= drawPiece(xloc,yloc,newqueen);  %draw new queen at location and return
       set(queen,'AlphaData',alpha_data_queen); %make new queen image transparent
end

%reset pieces to original positions and make all pieces visible
function [] = resetboard()

    global blackrookA;
    global blackknightA;
    global blackbishopA;
    global blackqueen;
    global blackking;
    global blackbishopB;
    global blackknightB;
    global blackrookB;
    global blackpawnA;
    global blackpawnB;
    global blackpawnC;
    global blackpawnD;
    global blackpawnE;
    global blackpawnF;
    global blackpawnG;
    global blackpawnH;
    global whiterookA;
    global whiteknightA;
    global whitebishopA;
    global whiteking;
    global whitequeen;
    global whitebishopB;
    global whiteknightB;
    global whiterookB;
    global whitepawnA;
    global whitepawnB;
    global whitepawnC;
    global whitepawnD;
    global whitepawnE;
    global whitepawnF;
    global whitepawnG;
    global whitepawnH;
    
    global pawn_flag_array;
    
    global turn;
    global endgame;
    turn=1;
    endgame=0;
    
    %undo queening
        if pawn_flag_array(1)==1
            blackpawnA=queen2pawn(blackpawnA,1);
        elseif pawn_flag_array(2)==1
            blackpawnB=queen2pawn(blackpawnB,2);
        elseif pawn_flag_array(3)==1
            blackpawnC=queen2pawn(blackpawnC,3);
        elseif pawn_flag_array(4)==1
            blackpawnD=queen2pawn(blackpawnD,4);
        elseif pawn_flag_array(5)==1
            blackpawnE=queen2pawn(blackpawnE,5);
        elseif pawn_flag_array(6)==1
            blackpawnF=queen2pawn(blackpawnF,6);
        elseif pawn_flag_array(7)==1
            blackpawnG=queen2pawn(blackpawnG,7);
        elseif pawn_flag_array(8)==1
            blackpawnH=queen2pawn(blackpawnH,8);
        elseif pawn_flag_array(9)==1
            whitepawnA=queen2pawn(whitepawnA,9);
        elseif pawn_flag_array(10)==1
            whitepawnB=queen2pawn(whitepawnB,10);
        elseif pawn_flag_array(11)==1
            whitepawnC=queen2pawn(whitepawnC,11);
        elseif pawn_flag_array(12)==1
            whitepawnD=queen2pawn(whitepawnD,12);
        elseif pawn_flag_array(13)==1
            whitepawnE=queen2pawn(whitepawnE,13);
        elseif pawn_flag_array(14)==1
            whitepawnF=queen2pawn(whitepawnF,14);
        elseif pawn_flag_array(15)==1
            whitepawnG=queen2pawn(whitepawnG,15);
        elseif pawn_flag_array(16)==1
            whitepawnH=queen2pawn(whitepawnH,16);
        end
        

set(blackrookA,'XData',0,'YData',420,'Visible','On');
set(blackknightA,'XData',60,'YData',420,'Visible','On');
set(blackbishopA,'XData',120,'YData',420,'Visible','On');
set(blackqueen,'XData',180,'YData',420,'Visible','On');
set(blackking,'XData',240,'YData',420,'Visible','On');
set(blackbishopB,'XData',300,'YData',420,'Visible','On');
set(blackknightB,'XData',360,'YData',420,'Visible','On');
set(blackrookB,'XData',420,'YData',420,'Visible','On');
set(blackpawnA,'XData',0,'YData',360,'Visible','On');
set(blackpawnB,'XData',60,'YData',360,'Visible','On');
set(blackpawnC,'XData',120,'YData',360,'Visible','On');
set(blackpawnD,'XData',180,'YData',360,'Visible','On');
set(blackpawnE,'XData',240,'YData',360,'Visible','On');
set(blackpawnF,'XData',300,'YData',360,'Visible','On');
set(blackpawnG,'XData',360,'YData',360,'Visible','On');
set(blackpawnH,'XData',420,'YData',360,'Visible','On');
set(whiterookA,'XData',0,'YData',0,'Visible','On');
set(whiteknightA,'XData',60,'YData',0,'Visible','On');
set(whitebishopA,'XData',120,'YData',0,'Visible','On');
set(whiteking,'XData',240,'YData',0,'Visible','On');
set(whitequeen,'XData',180,'YData',0,'Visible','On');
set(whitebishopB,'XData',300,'YData',0,'Visible','On');
set(whiteknightB,'XData',360,'YData',0,'Visible','On');
set(whiterookB,'XData',420,'YData',0,'Visible','On');
set(whitepawnA,'XData',0,'YData',60,'Visible','On');
set(whitepawnB,'XData',60,'YData',60,'Visible','On');
set(whitepawnC,'XData',120,'YData',60,'Visible','On');
set(whitepawnD,'XData',180,'YData',60,'Visible','On');
set(whitepawnE,'XData',240,'YData',60,'Visible','On');
set(whitepawnF,'XData',300,'YData',60,'Visible','On');
set(whitepawnG,'XData',360,'YData',60,'Visible','On');
set(whitepawnH,'XData',420,'YData',60,'Visible','On');
end

%turn queen image to pawn image
%useful when reset occurs and pawn2queen has been called
function [pawn] = queen2pawn(queen,index)

    global alpha_data_pawn;
    %global pawn_flag_array;
    
    %store location of queen
    xloc= get(queen,'XData');
    yloc= get(queen,'YData');
    delete(queen);
    %black if index is between 1-8, white if index is between 9-16
    if (index<=8)
        newpawn= imread(strcat('pieces\blackpawn1','.png'));
        newpawn= imrotate(newpawn,180,'crop');
    elseif (index<=16)
        newpawn= imread(strcat('pieces\whitepawn1','.png'));
        newpawn= imrotate(newpawn,180,'crop');
    end
    pawn= drawPiece(xloc,yloc,newpawn);
    set(pawn,'AlphaData',alpha_data_pawn);
end


%take coordinates and piece as parameters and move piece
function[out]= drawPiece(x,y,piece)
    xC= int16(x);
    yC= int16(y);
    xC= xC/60;  %re-adjust piece to fit square
    yC= yC/60;
    xC= xC*60;
    yC= yC*60;
    out= imagesc(xC,yC,piece);
end
